{ Imports for Java packages/classes: org.json. }
unit jsonobject;
{$mode delphi}

interface

type
  OJJSONArray = class;
  Arr1OJJSONArray = array of OJJSONArray;
  Arr2OJJSONArray = array of Arr1OJJSONArray;
  Arr3OJJSONArray = array of Arr2OJJSONArray;

  OJJSONException = class;
  Arr1OJJSONException = array of OJJSONException;
  Arr2OJJSONException = array of Arr1OJJSONException;
  Arr3OJJSONException = array of Arr2OJJSONException;

  OJJSONTokener = class;
  Arr1OJJSONTokener = array of OJJSONTokener;
  Arr2OJJSONTokener = array of Arr1OJJSONTokener;
  Arr3OJJSONTokener = array of Arr2OJJSONTokener;

  OJJSONObject = class;
  Arr1OJJSONObject = array of OJJSONObject;
  Arr2OJJSONObject = array of Arr1OJJSONObject;
  Arr3OJJSONObject = array of Arr2OJJSONObject;

  OJJSONString = interface;
  Arr1OJJSONString = array of OJJSONString;
  Arr2OJJSONString = array of Arr1OJJSONString;
  Arr3OJJSONString = array of Arr2OJJSONString;

  JLThrowable = class external 'java.lang' name 'Throwable';
  Arr1JLThrowable = array of JLThrowable;
  Arr2JLThrowable = array of Arr1JLThrowable;
  Arr3JLThrowable = array of Arr2JLThrowable;

  JLObject = class external 'java.lang' name 'Object';
  Arr1JLObject = array of JLObject;
  Arr2JLObject = array of Arr1JLObject;
  Arr3JLObject = array of Arr2JLObject;

  JIInputStream = class external 'java.io' name 'InputStream';
  Arr1JIInputStream = array of JIInputStream;
  Arr2JIInputStream = array of Arr1JIInputStream;
  Arr3JIInputStream = array of Arr2JIInputStream;

  JLEnum = class external 'java.lang' name 'Enum';
  Arr1JLEnum = array of JLEnum;
  Arr2JLEnum = array of Arr1JLEnum;
  Arr3JLEnum = array of Arr2JLEnum;

  JLNumber = class external 'java.lang' name 'Number';
  Arr1JLNumber = array of JLNumber;
  Arr2JLNumber = array of Arr1JLNumber;
  Arr3JLNumber = array of Arr2JLNumber;

  JMBigDecimal = class external 'java.math' name 'BigDecimal';
  Arr1JMBigDecimal = array of JMBigDecimal;
  Arr2JMBigDecimal = array of Arr1JMBigDecimal;
  Arr3JMBigDecimal = array of Arr2JMBigDecimal;

  JIWriter = class external 'java.io' name 'Writer';
  Arr1JIWriter = array of JIWriter;
  Arr2JIWriter = array of Arr1JIWriter;
  Arr3JIWriter = array of Arr2JIWriter;

  JMBigInteger = class external 'java.math' name 'BigInteger';
  Arr1JMBigInteger = array of JMBigInteger;
  Arr2JMBigInteger = array of Arr1JMBigInteger;
  Arr3JMBigInteger = array of Arr2JMBigInteger;

  JLString = class external 'java.lang' name 'String';
  Arr1JLString = array of JLString;
  Arr2JLString = array of Arr1JLString;
  Arr3JLString = array of Arr2JLString;

  JLClass = class external 'java.lang' name 'Class';
  Arr1JLClass = array of JLClass;
  Arr2JLClass = array of Arr1JLClass;
  Arr3JLClass = array of Arr2JLClass;

  JULocale = class external 'java.util' name 'Locale';
  Arr1JULocale = array of JULocale;
  Arr2JULocale = array of Arr1JULocale;
  Arr3JULocale = array of Arr2JULocale;

  JIReader = class external 'java.io' name 'Reader';
  Arr1JIReader = array of JIReader;
  Arr2JIReader = array of Arr1JIReader;
  Arr3JIReader = array of Arr2JIReader;

  JLRuntimeException = class external 'java.lang' name 'RuntimeException';
  Arr1JLRuntimeException = array of JLRuntimeException;
  Arr2JLRuntimeException = array of Arr1JLRuntimeException;
  Arr3JLRuntimeException = array of Arr2JLRuntimeException;

  JLIterable = interface external 'java.lang' name 'Iterable';
  Arr1JLIterable = array of JLIterable;
  Arr2JLIterable = array of Arr1JLIterable;
  Arr3JLIterable = array of Arr2JLIterable;

  JUIterator = interface external 'java.util' name 'Iterator';
  Arr1JUIterator = array of JUIterator;
  Arr2JUIterator = array of Arr1JUIterator;
  Arr3JUIterator = array of Arr2JUIterator;

  JUCollection = interface external 'java.util' name 'Collection';
  Arr1JUCollection = array of JUCollection;
  Arr2JUCollection = array of Arr1JUCollection;
  Arr3JUCollection = array of Arr2JUCollection;

  JUMap = interface external 'java.util' name 'Map';
  Arr1JUMap = array of JUMap;
  Arr2JUMap = array of Arr1JUMap;
  Arr3JUMap = array of Arr2JUMap;

  JUSet = interface external 'java.util' name 'Set';
  Arr1JUSet = array of JUSet;
  Arr2JUSet = array of Arr1JUSet;
  Arr3JUSet = array of Arr2JUSet;


{$include jsonobject.inc}

implementation

end.
