  OJJSONArray = class external 'org.json' name 'JSONArray' (JLObject, JLIterable)
  public
    constructor create(); overload;
    constructor create(para1: OJJSONTokener); overload;  // throws org.json.JSONException
    constructor create(para1: JLString); overload;  // throws org.json.JSONException
    constructor create(para1: JUCollection); overload;
    constructor create(para1: JLObject); overload;  // throws org.json.JSONException
    function iterator(): JUIterator; overload; virtual;
    function get(para1: jint): JLObject; overload; virtual;  // throws org.json.JSONException
    function getBoolean(para1: jint): jboolean; overload; virtual;  // throws org.json.JSONException
    function getDouble(para1: jint): jdouble; overload; virtual;  // throws org.json.JSONException
    function getEnum(para1: JLClass; para2: jint): JLEnum; overload; virtual;  // throws org.json.JSONException
    function getBigDecimal(para1: jint): JMBigDecimal; overload; virtual;  // throws org.json.JSONException
    function getBigInteger(para1: jint): JMBigInteger; overload; virtual;  // throws org.json.JSONException
    function getInt(para1: jint): jint; overload; virtual;  // throws org.json.JSONException
    function getJSONArray(para1: jint): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function getJSONObject(para1: jint): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function getLong(para1: jint): jlong; overload; virtual;  // throws org.json.JSONException
    function getString(para1: jint): JLString; overload; virtual;  // throws org.json.JSONException
    function isNull(para1: jint): jboolean; overload; virtual;
    function join(para1: JLString): JLString; overload; virtual;  // throws org.json.JSONException
    function length(): jint; overload; virtual;
    function opt(para1: jint): JLObject; overload; virtual;
    function optBoolean(para1: jint): jboolean; overload; virtual;
    function optBoolean(para1: jint; para2: jboolean): jboolean; overload; virtual;
    function optDouble(para1: jint): jdouble; overload; virtual;
    function optDouble(para1: jint; para2: jdouble): jdouble; overload; virtual;
    function optInt(para1: jint): jint; overload; virtual;
    function optInt(para1: jint; para2: jint): jint; overload; virtual;
    function optEnum(para1: JLClass; para2: jint): JLEnum; overload; virtual;
    function optEnum(para1: JLClass; para2: jint; para3: JLEnum): JLEnum; overload; virtual;
    function optBigInteger(para1: jint; para2: JMBigInteger): JMBigInteger; overload; virtual;
    function optBigDecimal(para1: jint; para2: JMBigDecimal): JMBigDecimal; overload; virtual;
    function optJSONArray(para1: jint): OJJSONArray; overload; virtual;
    function optJSONObject(para1: jint): OJJSONObject; overload; virtual;
    function optLong(para1: jint): jlong; overload; virtual;
    function optLong(para1: jint; para2: jlong): jlong; overload; virtual;
    function optString(para1: jint): JLString; overload; virtual;
    function optString(para1: jint; para2: JLString): JLString; overload; virtual;
    function put(para1: jboolean): OJJSONArray; overload; virtual;
    function put(para1: JUCollection): OJJSONArray; overload; virtual;
    function put(para1: jdouble): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint): OJJSONArray; overload; virtual;
    function put(para1: jlong): OJJSONArray; overload; virtual;
    function put(para1: JUMap): OJJSONArray; overload; virtual;
    function put(para1: JLObject): OJJSONArray; overload; virtual;
    function put(para1: jint; para2: jboolean): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: JUCollection): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: jdouble): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: jint): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: jlong): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: JUMap): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function put(para1: jint; para2: JLObject): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function remove(para1: jint): JLObject; overload; virtual;
    function similar(para1: JLObject): jboolean; overload; virtual;
    function toJSONObject(para1: OJJSONArray): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function toString(): JLString; overload; virtual;
    function toString(para1: jint): JLString; overload; virtual;  // throws org.json.JSONException
    function write(para1: JIWriter): JIWriter; overload; virtual;  // throws org.json.JSONException
  private
    function write(para1: JIWriter; para2: jint; para3: jint): JIWriter; overload; virtual;  // throws org.json.JSONException
  end;

  OJJSONObject = class external 'org.json' name 'JSONObject' (JLObject)
  public
    type
      InnerNull = class;
      Arr1InnerNull = array of InnerNull;
      Arr2InnerNull = array of Arr1InnerNull;
      Arr3InnerNull = array of Arr2InnerNull;
      InnerNull = class sealed external 'org.json' name 'Null' 
      end;

  public
    final class var
      fNULL: JLObject; external name 'NULL';
  public
    constructor create(); overload;
    constructor create(para1: OJJSONObject; para2: Arr1JLString); overload;
    constructor create(para1: OJJSONObject; const para2: array of JLString); overload;
    constructor create(para1: OJJSONTokener); overload;  // throws org.json.JSONException
    constructor create(para1: JUMap); overload;
    constructor create(para1: JLObject); overload;
    constructor create(para1: JLObject; para2: Arr1JLString); overload;
    constructor create(para1: JLObject; const para2: array of JLString); overload;
    constructor create(para1: JLString); overload;  // throws org.json.JSONException
    constructor create(para1: JLString; para2: JULocale); overload;  // throws org.json.JSONException
    function accumulate(para1: JLString; para2: JLObject): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function append(para1: JLString; para2: JLObject): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    class function doubleToString(para1: jdouble): JLString; static; overload;
    function get(para1: JLString): JLObject; overload; virtual;  // throws org.json.JSONException
    function getEnum(para1: JLClass; para2: JLString): JLEnum; overload; virtual;  // throws org.json.JSONException
    function getBoolean(para1: JLString): jboolean; overload; virtual;  // throws org.json.JSONException
    function getBigInteger(para1: JLString): JMBigInteger; overload; virtual;  // throws org.json.JSONException
    function getBigDecimal(para1: JLString): JMBigDecimal; overload; virtual;  // throws org.json.JSONException
    function getDouble(para1: JLString): jdouble; overload; virtual;  // throws org.json.JSONException
    function getInt(para1: JLString): jint; overload; virtual;  // throws org.json.JSONException
    function getJSONArray(para1: JLString): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function getJSONObject(para1: JLString): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function getLong(para1: JLString): jlong; overload; virtual;  // throws org.json.JSONException
    class function getNames(para1: OJJSONObject): Arr1JLString; static; overload;
    class function getNames(para1: JLObject): Arr1JLString; static; overload;
    function getString(para1: JLString): JLString; overload; virtual;  // throws org.json.JSONException
    function has(para1: JLString): jboolean; overload; virtual;
    function increment(para1: JLString): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function isNull(para1: JLString): jboolean; overload; virtual;
    function keys(): JUIterator; overload; virtual;
    function keySet(): JUSet; overload; virtual;
    function length(): jint; overload; virtual;
    function names(): OJJSONArray; overload; virtual;
    class function numberToString(para1: JLNumber): JLString; static; overload;  // throws org.json.JSONException
    function opt(para1: JLString): JLObject; overload; virtual;
    function optEnum(para1: JLClass; para2: JLString): JLEnum; overload; virtual;
    function optEnum(para1: JLClass; para2: JLString; para3: JLEnum): JLEnum; overload; virtual;
    function optBoolean(para1: JLString): jboolean; overload; virtual;
    function optBoolean(para1: JLString; para2: jboolean): jboolean; overload; virtual;
    function optDouble(para1: JLString): jdouble; overload; virtual;
    function optBigInteger(para1: JLString; para2: JMBigInteger): JMBigInteger; overload; virtual;
    function optBigDecimal(para1: JLString; para2: JMBigDecimal): JMBigDecimal; overload; virtual;
    function optDouble(para1: JLString; para2: jdouble): jdouble; overload; virtual;
    function optInt(para1: JLString): jint; overload; virtual;
    function optInt(para1: JLString; para2: jint): jint; overload; virtual;
    function optJSONArray(para1: JLString): OJJSONArray; overload; virtual;
    function optJSONObject(para1: JLString): OJJSONObject; overload; virtual;
    function optLong(para1: JLString): jlong; overload; virtual;
    function optLong(para1: JLString; para2: jlong): jlong; overload; virtual;
    function optString(para1: JLString): JLString; overload; virtual;
    function optString(para1: JLString; para2: JLString): JLString; overload; virtual;
    function put(para1: JLString; para2: jboolean): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: JUCollection): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: jdouble): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: jint): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: jlong): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: JUMap): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function put(para1: JLString; para2: JLObject): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function putOnce(para1: JLString; para2: JLObject): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    function putOpt(para1: JLString; para2: JLObject): OJJSONObject; overload; virtual;  // throws org.json.JSONException
    class function quote(para1: JLString): JLString; static; overload;
    class function quote(para1: JLString; para2: JIWriter): JIWriter; static; overload;  // throws java.io.IOException
    function remove(para1: JLString): JLObject; overload; virtual;
    function similar(para1: JLObject): jboolean; overload; virtual;
    class function stringToValue(para1: JLString): JLObject; static; overload;
    class procedure testValidity(para1: JLObject); static; overload;  // throws org.json.JSONException
    function toJSONArray(para1: OJJSONArray): OJJSONArray; overload; virtual;  // throws org.json.JSONException
    function toString(): JLString; overload; virtual;
    function toString(para1: jint): JLString; overload; virtual;  // throws org.json.JSONException
    class function valueToString(para1: JLObject): JLString; static; overload;  // throws org.json.JSONException
    class function wrap(para1: JLObject): JLObject; static; overload;
    function write(para1: JIWriter): JIWriter; overload; virtual;  // throws org.json.JSONException
  private
    class function writeValue(para1: JIWriter; para2: JLObject; para3: jint; para4: jint): JIWriter; static; overload; final;  // throws org.json.JSONException, java.io.IOException
    class procedure indent(para1: JIWriter; para2: jint); static; overload; final;  // throws java.io.IOException
    function write(para1: JIWriter; para2: jint; para3: jint): JIWriter; overload; virtual;  // throws org.json.JSONException
  end;

  OJJSONString = interface external 'org.json' name 'JSONString' 
    function toJSONString(): JLString; overload;
  end;

  OJJSONTokener = class external 'org.json' name 'JSONTokener' (JLObject)
  public
    constructor create(para1: JIReader); overload;
    constructor create(para1: JIInputStream); overload;  // throws org.json.JSONException
    constructor create(para1: JLString); overload;
    procedure back(); overload; virtual;  // throws org.json.JSONException
    class function dehexchar(para1: jchar): jint; static; overload;
    function &end(): jboolean; overload; virtual;
    function more(): jboolean; overload; virtual;  // throws org.json.JSONException
    function next(): jchar; overload; virtual;  // throws org.json.JSONException
    function next(para1: jchar): jchar; overload; virtual;  // throws org.json.JSONException
    function next(para1: jint): JLString; overload; virtual;  // throws org.json.JSONException
    function nextClean(): jchar; overload; virtual;  // throws org.json.JSONException
    function nextString(para1: jchar): JLString; overload; virtual;  // throws org.json.JSONException
    function nextTo(para1: jchar): JLString; overload; virtual;  // throws org.json.JSONException
    function nextTo(para1: JLString): JLString; overload; virtual;  // throws org.json.JSONException
    function nextValue(): JLObject; overload; virtual;  // throws org.json.JSONException
    function skipTo(para1: jchar): jchar; overload; virtual;  // throws org.json.JSONException
    function syntaxError(para1: JLString): OJJSONException; overload; virtual;
    function toString(): JLString; overload; virtual;
  end;

  OJJSONException = class external 'org.json' name 'JSONException' (JLRuntimeException)
  public
    constructor create(para1: JLString); overload;
    constructor create(para1: JLThrowable); overload;
    function getCause(): JLThrowable; overload; virtual;
  end;

